import { CowWidgetEventListeners } from '@cowprotocol/events';
import { CowSwapWidgetParams, CowSwapWidgetProps, EthereumProvider } from './types';
/**
 * Callback function signature for updating the CoW Swap Widget.
 */
export interface CowSwapWidgetHandler {
    updateParams: (params: CowSwapWidgetParams) => void;
    updateListeners: (newListeners?: CowWidgetEventListeners) => void;
    updateProvider: (newProvider?: EthereumProvider) => void;
    destroy: () => void;
}
/**
 * Generates and injects a CoW Swap Widget into the provided container.
 * @param container - The HTML element to inject the widget into.
 * @param params - Parameters for configuring the widget.
 * @returns A callback function to update the widget with new settings.
 */
export declare function createCowSwapWidget(container: HTMLElement, props: CowSwapWidgetProps): CowSwapWidgetHandler;
