var H = Object.defineProperty;
var Q = (e, t, n) => t in e ? H(e, t, { enumerable: !0, configurable: !0, writable: !0, value: n }) : e[t] = n;
var w = (e, t, n) => Q(e, typeof t != "symbol" ? t + "" : t, n);
class b {
  constructor(t) {
    this.key = t;
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  postMessageToWindow(t, n, s) {
    const p = typeof s == "object" ? s : {}, l = {
      key: this.key,
      method: n,
      ...p
    };
    t.postMessage(
      l,
      "*"
      // TODO: Change to CoW specific origin in production. https://github.com/cowprotocol/cowswap/issues/3828
    );
  }
  listenToMessageFromWindow(t, n, s) {
    const p = (l) => {
      !G(l.data) || l.data.key !== this.key || l.data.method !== n || s(l.data);
    };
    return t.addEventListener("message", p), p;
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  stopListeningToMessageFromWindow(t, n, s) {
    t.removeEventListener("message", s);
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  stopListeningWindowListener(t, n) {
    t.removeEventListener("message", n);
  }
}
function G(e) {
  return typeof e == "object" && e !== null && "key" in e && "method" in e && typeof e.key == "string" && typeof e.method == "string";
}
var P = /* @__PURE__ */ ((e) => (e.PROVIDER_RPC_REQUEST = "PROVIDER_RPC_REQUEST", e.PROVIDER_RPC_RESPONSE = "PROVIDER_RPC_RESPONSE", e.PROVIDER_ON_EVENT = "PROVIDER_ON_EVENT", e.SEND_PROVIDER_META_INFO = "SEND_PROVIDER_META_INFO", e.REQUEST_PROVIDER_META_INFO = "REQUEST_PROVIDER_META_INFO", e))(P || {});
const g = new b(
  "cowSwapIframeRpcProviderTransport"
);
function q(e) {
  var t, n;
  if (e.isWalletConnect)
    return (n = (t = e == null ? void 0 : e.session) == null ? void 0 : t.peer) == null ? void 0 : n.metadata;
}
function j(e, t) {
  var n;
  return (n = t.find((s) => s.provider === e)) == null ? void 0 : n.info;
}
const $ = ["connect", "disconnect", "close", "chainChanged", "accountsChanged"], V = [];
window.addEventListener("eip6963:announceProvider", (e) => {
  const t = e;
  V.push(t.detail);
});
class B {
  /**
   * Creates an instance of IframeRpcProviderBridge.
   * @param iframeWidow - The iFrame window that will post up general RPC messages and to which the IframeRpcProviderBridge will forward the RPC result.
   *  Also it will receive some special RPC events coming from the wallet, like connect/chainChanged,accountChanged
   */
  constructor(t) {
    /**
     * The Ethereum provider instance.
     * When is null the JSON-RPC bridge is disconnected from the Ethereum provider.
     * */
    w(this, "ethereumProvider", null);
    /** Stored JSON-RPC requests, to queue them when disconnected. */
    w(this, "requestWaitingForConnection", {});
    w(this, "processRpcCallFromWindow", ({ rpcRequest: t }) => {
      if (!this.ethereumProvider) {
        t.id && (this.requestWaitingForConnection[t.id] = t);
        return;
      }
      this.processRpcRequest(t);
    });
    w(this, "processProviderMetaInfoRequest", () => {
      if (!this.ethereumProvider) return;
      const t = j(this.ethereumProvider, V), n = q(this.ethereumProvider);
      g.postMessageToWindow(this.iframeWidow, P.SEND_PROVIDER_META_INFO, {
        providerEip6963Info: t,
        providerWcMetadata: n
      });
    });
    this.iframeWidow = t;
  }
  /**
   * Disconnects the JSON-RPC bridge from the Ethereum provider.
   */
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  disconnect() {
    this.ethereumProvider = null, g.stopListeningToMessageFromWindow(
      window,
      P.PROVIDER_RPC_REQUEST,
      this.processRpcCallFromWindow
    ), g.stopListeningToMessageFromWindow(
      window,
      P.REQUEST_PROVIDER_META_INFO,
      this.processProviderMetaInfoRequest
    );
  }
  /**
   * Handles the 'connect' event and sets up event listeners for Ethereum provider events.
   * @param newProvider - The Ethereum provider to connect.
   */
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  onConnect(t) {
    this.ethereumProvider ? this.disconnect() : g.listenToMessageFromWindow(
      window,
      P.PROVIDER_RPC_REQUEST,
      this.processRpcCallFromWindow
    ), this.ethereumProvider = t, this.processPendingRequests(), $.forEach((n) => {
      t.on(n, (s) => this.onProviderEvent(n, s));
    }), g.listenToMessageFromWindow(
      window,
      P.REQUEST_PROVIDER_META_INFO,
      this.processProviderMetaInfoRequest
    );
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  processPendingRequests() {
    Object.keys(this.requestWaitingForConnection).forEach((t) => {
      this.processRpcRequest(this.requestWaitingForConnection[t]);
    }), this.requestWaitingForConnection = {};
  }
  /**
   * Processes a JSON-RPC request and sends appropriate response or error via the content window.
   * @param request - The JSON-RPC request to be processed.
   */
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  processRpcRequest(t) {
    const { id: n, jsonrpc: s, method: p } = t;
    if (!this.ethereumProvider || !n)
      return;
    (p === "enable" ? this.ethereumProvider.enable() : this.ethereumProvider.request({ ...t, id: n })).then(
      (_) => this.forwardRpcResponseToIframe({
        rpcResponse: { jsonrpc: s, id: n, result: _ }
      })
    ).catch(
      (_) => this.forwardRpcResponseToIframe({
        rpcResponse: { jsonrpc: s, id: n, error: _ }
      })
    );
  }
  onProviderEvent(t, n) {
    g.postMessageToWindow(this.iframeWidow, P.PROVIDER_ON_EVENT, {
      event: t,
      params: n
    });
  }
  /**
   * Forward a JSON-RPC message to the content window.
   */
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  forwardRpcResponseToIframe(t) {
    g.postMessageToWindow(
      this.iframeWidow,
      P.PROVIDER_RPC_RESPONSE,
      t
    );
  }
}
var C = { exports: {} }, S;
function Y() {
  return S || (S = 1, function(e) {
    var t = Object.prototype.hasOwnProperty, n = "~";
    function s() {
    }
    Object.create && (s.prototype = /* @__PURE__ */ Object.create(null), new s().__proto__ || (n = !1));
    function p(c, r, o) {
      this.fn = c, this.context = r, this.once = o || !1;
    }
    function l(c, r, o, i, E) {
      if (typeof o != "function")
        throw new TypeError("The listener must be a function");
      var d = new p(o, i || c, E), f = n ? n + r : r;
      return c._events[f] ? c._events[f].fn ? c._events[f] = [c._events[f], d] : c._events[f].push(d) : (c._events[f] = d, c._eventsCount++), c;
    }
    function _(c, r) {
      --c._eventsCount === 0 ? c._events = new s() : delete c._events[r];
    }
    function u() {
      this._events = new s(), this._eventsCount = 0;
    }
    u.prototype.eventNames = function() {
      var r = [], o, i;
      if (this._eventsCount === 0) return r;
      for (i in o = this._events)
        t.call(o, i) && r.push(n ? i.slice(1) : i);
      return Object.getOwnPropertySymbols ? r.concat(Object.getOwnPropertySymbols(o)) : r;
    }, u.prototype.listeners = function(r) {
      var o = n ? n + r : r, i = this._events[o];
      if (!i) return [];
      if (i.fn) return [i.fn];
      for (var E = 0, d = i.length, f = new Array(d); E < d; E++)
        f[E] = i[E].fn;
      return f;
    }, u.prototype.listenerCount = function(r) {
      var o = n ? n + r : r, i = this._events[o];
      return i ? i.fn ? 1 : i.length : 0;
    }, u.prototype.emit = function(r, o, i, E, d, f) {
      var T = n ? n + r : r;
      if (!this._events[T]) return !1;
      var a = this._events[T], R = arguments.length, v, h;
      if (a.fn) {
        switch (a.once && this.removeListener(r, a.fn, void 0, !0), R) {
          case 1:
            return a.fn.call(a.context), !0;
          case 2:
            return a.fn.call(a.context, o), !0;
          case 3:
            return a.fn.call(a.context, o, i), !0;
          case 4:
            return a.fn.call(a.context, o, i, E), !0;
          case 5:
            return a.fn.call(a.context, o, i, E, d), !0;
          case 6:
            return a.fn.call(a.context, o, i, E, d, f), !0;
        }
        for (h = 1, v = new Array(R - 1); h < R; h++)
          v[h - 1] = arguments[h];
        a.fn.apply(a.context, v);
      } else {
        var k = a.length, O;
        for (h = 0; h < k; h++)
          switch (a[h].once && this.removeListener(r, a[h].fn, void 0, !0), R) {
            case 1:
              a[h].fn.call(a[h].context);
              break;
            case 2:
              a[h].fn.call(a[h].context, o);
              break;
            case 3:
              a[h].fn.call(a[h].context, o, i);
              break;
            case 4:
              a[h].fn.call(a[h].context, o, i, E);
              break;
            default:
              if (!v) for (O = 1, v = new Array(R - 1); O < R; O++)
                v[O - 1] = arguments[O];
              a[h].fn.apply(a[h].context, v);
          }
      }
      return !0;
    }, u.prototype.on = function(r, o, i) {
      return l(this, r, o, i, !1);
    }, u.prototype.once = function(r, o, i) {
      return l(this, r, o, i, !0);
    }, u.prototype.removeListener = function(r, o, i, E) {
      var d = n ? n + r : r;
      if (!this._events[d]) return this;
      if (!o)
        return _(this, d), this;
      var f = this._events[d];
      if (f.fn)
        f.fn === o && (!E || f.once) && (!i || f.context === i) && _(this, d);
      else {
        for (var T = 0, a = [], R = f.length; T < R; T++)
          (f[T].fn !== o || E && !f[T].once || i && f[T].context !== i) && a.push(f[T]);
        a.length ? this._events[d] = a.length === 1 ? a[0] : a : _(this, d);
      }
      return this;
    }, u.prototype.removeAllListeners = function(r) {
      var o;
      return r ? (o = n ? n + r : r, this._events[o] && _(this, o)) : (this._events = new s(), this._eventsCount = 0), this;
    }, u.prototype.off = u.prototype.removeListener, u.prototype.addListener = u.prototype.on, u.prefixed = n, u.EventEmitter = u, e.exports = u;
  }(C)), C.exports;
}
Y();
class z {
  constructor() {
    w(this, "subscriptions", {});
  }
  on(t) {
    const { event: n, handler: s } = t;
    return this.subscriptions[n] || (this.subscriptions[n] = []), this.subscriptions[n].push(s), t;
  }
  off(t) {
    const { event: n, handler: s } = t;
    return this.subscriptions[n] && (this.subscriptions[n] = this.subscriptions[n].filter((p) => p !== s)), t;
  }
  emit(t, n) {
    this.subscriptions[t] && this.subscriptions[t].forEach((s) => s(n));
  }
}
var I = /* @__PURE__ */ ((e) => (e.ACTIVATE = "ACTIVATE", e.UPDATE_HEIGHT = "UPDATE_HEIGHT", e.SET_FULL_HEIGHT = "SET_FULL_HEIGHT", e.EMIT_COW_EVENT = "EMIT_COW_EVENT", e.PROVIDER_RPC_REQUEST = "PROVIDER_RPC_REQUEST", e.INTERCEPT_WINDOW_OPEN = "INTERCEPT_WINDOW_OPEN", e))(I || {}), A = /* @__PURE__ */ ((e) => (e.UPDATE_PARAMS = "UPDATE_PARAMS", e.UPDATE_APP_DATA = "UPDATE_APP_DATA", e.PROVIDER_RPC_RESPONSE = "PROVIDER_RPC_RESPONSE", e.PROVIDER_ON_EVENT = "PROVIDER_ON_EVENT", e))(A || {}), W = /* @__PURE__ */ ((e) => (e.SWAP = "swap", e.LIMIT = "limit", e.ADVANCED = "advanced", e.YIELD = "yield", e))(W || {});
const Ee = [
  "primary",
  "background",
  "paper",
  "text",
  "danger",
  "warning",
  "alert",
  "info",
  "success"
], m = new b("cowSwapWidget");
class J {
  constructor(t, n = []) {
    w(this, "eventEmitter", new z());
    w(this, "listeners", []);
    w(this, "widgetListener");
    this.contentWindow = t, this.updateListeners(n), this.widgetListener = m.listenToMessageFromWindow(
      this.contentWindow,
      I.EMIT_COW_EVENT,
      (s) => this.eventEmitter.emit(s.event, s.payload)
    );
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  stopListeningIframe() {
    m.stopListeningWindowListener(this.contentWindow, this.widgetListener);
  }
  updateListeners(t) {
    for (const n of this.listeners)
      this.eventEmitter.off(n);
    this.listeners = t || [];
    for (const n of this.listeners)
      this.eventEmitter.on(n);
  }
}
class K {
  constructor(t, n) {
    w(this, "forwardSdkMessage");
    this.appWindow = t, this.iframeWidow = n, this.forwardSdkMessage = (s) => {
      X(s.data) && s.origin !== window.location.origin && (Z(s.data) ? this.appWindow.parent.postMessage(s.data, "*") : ee(s.data) && this.iframeWidow.postMessage(s.data, "*"));
    }, this.startListening();
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  startListening() {
    this.appWindow.addEventListener("message", this.forwardSdkMessage);
  }
  // TODO: Add proper return type annotation
  // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
  stopListening() {
    this.appWindow.removeEventListener("message", this.forwardSdkMessage);
  }
}
function X(e) {
  return typeof e == "object" && e !== null && "id" in e && typeof e.id == "string";
}
function Z(e) {
  return "method" in e && typeof e.method == "string" && "params" in e && "env" in e && typeof e.env == "object" && e.env !== null && "sdkVersion" in e.env;
}
function ee(e) {
  return "success" in e && typeof e.success == "boolean" && "version" in e && typeof e.version == "string";
}
function te(e) {
  return !!(e && typeof e == "object");
}
const y = "_";
function ne(e) {
  const t = typeof e.baseUrl == "string" ? e.baseUrl : "https://swap.cow.fi", n = F(e);
  return t + "/#" + n + "?" + U(e);
}
function F(e) {
  const { chainId: t = 1, sell: n, buy: s, tradeType: p = W.SWAP } = e, l = [(n == null ? void 0 : n.asset) || y, (s == null ? void 0 : s.asset) || y].map(encodeURIComponent).join("/");
  return `/${t}/widget/${p}/${l}`;
}
function U(e) {
  const t = new URLSearchParams();
  return oe(re(se(t, e), e), e);
}
function se(e, t) {
  const { sell: n, buy: s } = t;
  return n != null && n.amount && e.append("sellAmount", n.amount), s != null && s.amount && e.append("buyAmount", s.amount), e;
}
function re(e, t) {
  const n = t.theme;
  return n ? (te(n) ? (e.append("palette", encodeURIComponent(JSON.stringify(n))), e.append("theme", n.baseTheme)) : (e.append("palette", "null"), e.append("theme", n)), e) : (e.append("palette", "null"), e);
}
function oe(e, t) {
  return t.targetChainId && e.append("targetChainId", t.targetChainId.toString()), e;
}
const x = "640px", ie = "450px", ae = 20;
function _e(e, t) {
  const { params: n, provider: s, listeners: p } = t;
  let l = s, _ = n;
  const u = ce(n);
  e.innerHTML = "", e.appendChild(u);
  const { contentWindow: c } = u;
  if (!c)
    throw console.error("Iframe does not contain a window", u), new Error("Iframe does not contain a window!");
  const r = [];
  r.push(ue(c, n.appCode)), r.push(...fe(u, n.height, n.maxHeight)), r.push(de());
  const o = new J(window, p);
  let i = D(c, null, l);
  u.addEventListener("load", () => L(c, _, l));
  const E = new K(window, c);
  return {
    updateParams: (d) => {
      _ = d, L(c, _, l);
    },
    updateListeners: (d) => o.updateListeners(d),
    updateProvider: (d) => {
      l = d, i = D(c, i, d);
    },
    destroy: () => {
      i.disconnect(), o.stopListeningIframe(), r.forEach((d) => window.removeEventListener("message", d)), E.stopListening(), e.removeChild(u);
    }
  };
}
function D(e, t, n) {
  t && t.disconnect();
  const s = t || new B(e);
  return n && s.onConnect(n), s;
}
function ce(e) {
  const { width: t = ie, height: n = x } = e, s = document.createElement("iframe");
  return s.src = ne(e), s.width = t, s.height = n, s.style.border = "0", s.allow = "clipboard-read; clipboard-write", s;
}
function L(e, t, n) {
  const s = !!n, p = F(t), l = U(t).toString(), { theme: _, ...u } = t;
  m.postMessageToWindow(e, A.UPDATE_PARAMS, {
    urlParams: {
      pathname: p,
      search: l
    },
    appParams: u,
    hasProvider: s
  });
}
function ue(e, t) {
  return m.listenToMessageFromWindow(window, I.ACTIVATE, () => {
    m.postMessageToWindow(e, A.UPDATE_APP_DATA, {
      metaData: t ? { appCode: t } : void 0
    });
  });
}
function de() {
  return m.listenToMessageFromWindow(
    window,
    I.INTERCEPT_WINDOW_OPEN,
    ({ href: e, rel: t, target: n }) => {
      const s = e.toString();
      if (!s.startsWith("http") && s.match(/^[a-zA-Z0-9]+:\/\//)) {
        window.open(s, n, t);
        return;
      }
    }
  );
}
function fe(e, t = x, n) {
  return [
    m.listenToMessageFromWindow(window, I.UPDATE_HEIGHT, (s) => {
      const p = s.height ? s.height + ae : void 0;
      e.style.height = p ? `${n ? Math.min(p, n) : p}px` : t;
    }),
    m.listenToMessageFromWindow(window, I.SET_FULL_HEIGHT, ({ isUpToSmall: s }) => {
      e.style.height = s ? t : `${n || document.body.offsetHeight}px`;
    })
  ];
}
const pe = Object.values(W);
function we(e, t, n) {
  if (N(e)) {
    const s = e[n];
    return M(s) ? s[t] : s;
  }
  if (M(e)) {
    const s = e[t];
    return N(s) ? s[n] : s;
  }
  return e;
}
function N(e) {
  return typeof e != "object" ? !1 : Object.keys(e).every((t) => pe.includes(t));
}
const he = /^\d+$/;
function M(e) {
  return typeof e != "object" ? !1 : Object.keys(e).every((t) => typeof t == "number" || he.test(t));
}
export {
  W as TradeType,
  Ee as WIDGET_PALETTE_COLORS,
  I as WidgetMethodsEmit,
  A as WidgetMethodsListen,
  _e as createCowSwapWidget,
  te as isCowSwapWidgetPalette,
  M as isPerNetworkConfig,
  N as isPerTradeTypeConfig,
  we as resolveFlexibleConfig,
  m as widgetIframeTransport
};
